#include "include.h"
#include "LOCclient/client.h"

static char *parse_cp (char *s, char *h, short *p)
{
	char *c;

	if ((c = strchr (s, '/'))) {
		strncpy (h, s, c - s);
		h [c - s] = 0;
		*p = strtoul (c + 1, &c, 10);
		return (*c == '/') ? c + 1 : c;
	}

	return NULL;
}

static int contact_dns (char *hp)	// hp= "badu.edu/1234"
{
	char host [MAX_PRL];
	short port;

	if (parse_cp (hp, host, &port))
		return connect_tcp (host, port);

	return -1;
}

static int contact_loc (char *hpu)	// hpu= "freeloc.org/9091/john"
{
	char host [MAX_PRL], *c;
	short port;
	int r = -1;

	if ((c = parse_cp (hpu, host, &port)))
		r = connect_LOC_user (c, host, port);

	return (r < 0) ? -1 : r;
}

bool change_LOC_passwd (char *np)
{
	char host [MAX_PRL], *c;
	short port;
	bool b = false;

	if ((c = parse_cp (Globals.ThisPoint + 5, host, &port)))
		b = change_LOC_passwd (host, port, c, Globals.LOCpass, np);
	if (b) {
		delete [] Globals.LOCpass;
		Globals.LOCpass = StrDup (np);
	}

	return b;
}

bool contact (char *cp, i_argstream &I, char *auth, int &ver)
{
	char buffer [MAX_PRL], v [10];
	int fd = -1;

DPRINTF (DB_SLOT2, "+++Try to contact [%s]\n", cp);
	if (!strncasecmp (cp, Globals.ThisPoint, strlen (Globals.ThisPoint)))
		fd = connect_tcp (LOCALHOST, Globals.LocalPort);
	else if (!strncasecmp (cp, "/dns/", 5))
		fd = contact_dns (cp + 5);
	else if (!strncasecmp (cp, "/loc/", 5))
		fd = contact_loc (cp + 5);

DPRINTF (DB_SLOT2, "+++Okie fd=%i\n", fd);
	if (fd == -1) return false;

	/* PROTOCOL-STUFF-LOCATION*/
	I.fd = fd;
	if (I.getarg (buffer, 10) == GETARG_OK
	&& PMSGtype (buffer) == PVERSION
	&& I.getarg (v, 10) == GETARG_OK
	&& I.getarg (auth, MAX_AUTHOR) == GETARG_OK
	&& I.getarg (buffer, MAX_PRL) == GETARG_OK
	&& !strcasecmp (cp, buffer)) {

		ver = strtoul (buffer, NULL, 10);
		return true;

	}

	close (fd);
	return false;
}

// ############################################
// this is how we listen in our	contact point.
// In the end this is the main server routine,
// it will call do_client with every connection.
// ############################################

const char MBadAddr []		= "My contact address is malformed: %s\n";
const char SNetErr []		= "Error setting up server: %s\n";
const char LOC_na []		= "LOC server [%s] not reachable\n";
const char LOCnou []		= "Failed login as [%s] to [%s]\n";
const char dynip []		= "The address \"%s\" does not refer to this host.\nRun 'postnet -c' to adjust your contact address.\n";
const char portreserved []	= "TCP port %i already in use ?\neither wait or kill the application using it\n";

static void enter_locr ()
{
	char host [MAX_PRL], *c;
	short port;
	int fd, client;

	if (!(c = parse_cp (Globals.ThisPoint + 5, host, &port))) {
		fprintf (stderr, MBadAddr, Globals.ThisPoint);
		return;
	}

	Globals.LocalPort = 0;
	if ((fd = listen_tcp (&Globals.LocalPort)) == -1) {
		fprintf (stderr, SNetErr, strerror (errno));
		return;
	}

	LOCreachable L (c, Globals.LOCpass, host, port, Globals.LocalPort);

	if (L.result != 1) {
		if (L.result == -2) fprintf (stderr, LOCnou, host, c);
		else fprintf (stderr, LOC_na, host);
		close (fd);
		return;
	}

	// one for the queuer
	sem_post (&Globals.DatabaseLock);
	// two for the initial value
	sem_post (&Globals.DatabaseLock);
	while ((client = accept_client (fd)) != -1)
		do_client (client);
	sem_wait (&Globals.DatabaseLock);
}

static void *enter_loop (void*)
{
	Globals.LocalPort = 0;
	int client, fd = listen_tcp (&Globals.LocalPort);
	while ((client = accept_client (fd)) != -1)
		do_client (client);
	return NULL;
}

static void backdoor ()
{
	// nothing like a microsloth backdoor. Just firewalled clients
	// don't listen for connections and we need that to
	// contact outself to the LocalPort shortcut.
	pthread_t t;
	pthread_create (&t, NULL, enter_loop, NULL);
	pthread_detach (t);
}

static void enter_locf ()
{
	char host [MAX_PRL], *c;
	short port;
	int client;

	if (!(c = parse_cp (Globals.ThisPoint + 5, host, &port))) {
		fprintf (stderr, MBadAddr, Globals.ThisPoint);
		return;
	}

	LOCfirewalled L (c, Globals.LOCpass, host, port);

	if (L.result != 1) {
		if (L.result == -2) fprintf (stderr, LOCnou, host, c);
		else fprintf (stderr, LOC_na, host);
		return;
	}

	sem_post (&Globals.DatabaseLock);
	sem_post (&Globals.DatabaseLock);
	backdoor ();
	while ((client = L.accept ()) != -1)
		do_client (client);
	sem_wait (&Globals.DatabaseLock);
}

static void enter_dns ()
{
	char host [MAX_PRL], *c;
	int fd, client;

	if (!(c = parse_cp (Globals.ThisPoint + 5, host, &Globals.LocalPort))) {
		fprintf (stderr, MBadAddr, Globals.ThisPoint);
		return;
	}

	if (!isitme (host)) {
		fprintf (stderr, dynip, host);
		return;
	}

	if ((fd = listen_tcp (&Globals.LocalPort)) == -1) {
		fprintf (stderr, portreserved, Globals.LocalPort);
		return;
	}

	sem_post (&Globals.DatabaseLock);
	sem_post (&Globals.DatabaseLock);
	while ((client = accept_client (fd)) != -1)
		do_client (client);
	sem_wait (&Globals.DatabaseLock);
}

void enter_POSTNET ()
{
	if (!strncasecmp (Globals.ThisPoint, "/dns/", 5))
		enter_dns ();
	else if (!strncasecmp (Globals.ThisPoint, "/loc/", 5))
		if (Globals.AmIFirewalled) enter_locf ();
		else enter_locr ();
	else fprintf (stderr, MBadAddr, Globals.ThisPoint);
}
